
/*****************************************************************************/
/****************** (C) 1991, 1992 by Miroslav Kolar *************************/
/*									     */
/* This is the header file for 1D.c, RanGen.c, RanGen1.c, timing.c, DR.c, .. */
/*									     */
/*      Classical & quantum Monte-Carlo simulation for a single		     */
/*       particle in a one-dimensional external potential V(x)               */
/*									     */
/*****************************************************************************/

#include <stdio.h>                  
#include <math.h>
#include <string.h>

#define PE         (void)fprintf(stderr,
#define PR         (void)fprintf(Listing,
#define PO         (void)fprintf(Output,
#define PD         (void)fprintf(Density,

#ifndef ultrix

/*      fseek() values  */
#define SEEK_SET 0
#define SEEK_CUR 1
#define SEEK_END 2
#define CLOCKS_PER_SEC 1000000

#define WD(x,n)  (void)fwrite((char *) x, sizeof(double), (size_t) n, Output);
#define WF(x,n)  (void)fwrite((char *) x, sizeof(float), (size_t) n, Output);
#define WL(x,n)  (void)fwrite((char *) x, sizeof(long), (size_t) n, Output);
#define WI(x,n)  (void)fwrite((char *) x, sizeof(int), (size_t) n, Output);
#define WU(x,n)  (void)fwrite((char *) x, sizeof(unsigned), (size_t) n, Output);
#define WUS(x,n) (void)fwrite((char *) x, sizeof(unsigned short), (size_t) n, Output);

#define RD(x,n) if(!fread((char *)x,sizeof(double),(size_t)n,Input)) err_fread(p);
#define RF(x,n) if(!fread((char *)x,sizeof(float),(size_t)n,Input)) err_fread(p);
#define RL(x,n) if(!fread((char *)x,sizeof(long),(size_t)n,Input)) err_fread(p);
#define RI(x,n) if(!fread((char *)x,sizeof(int),(size_t)n,Input)) err_fread(p);
#define RU(x,n) if(!fread((char *)x,sizeof(unsigned),(size_t)n,Input)) err_fread(p);
#define RUS(x,n) if(!fread((char *)x,sizeof(unsigned short),(size_t)n,Input)) err_fread(p);

#else

#define WD(x,n)  (void)fwrite((void *) x, sizeof(double), (size_t) n, Output);
#define WF(x,n)  (void)fwrite((void *) x, sizeof(float), (size_t) n, Output);
#define WL(x,n)  (void)fwrite((void *) x, sizeof(long), (size_t) n, Output);
#define WI(x,n)  (void)fwrite((void *) x, sizeof(int), (size_t) n, Output);
#define WU(x,n)  (void)fwrite((void *) x, sizeof(unsigned), (size_t) n, Output);
#define WUS(x,n) (void)fwrite((void *) x, sizeof(unsigned short), (size_t) n, Output);

#define RD(x,n) if(!fread((void *)x,sizeof(double),(size_t)n,Input)) err_fread(p);
#define RF(x,n) if(!fread((void *)x,sizeof(float),(size_t)n,Input)) err_fread(p);
#define RL(x,n) if(!fread((void *)x,sizeof(long),(size_t)n,Input)) err_fread(p);
#define RI(x,n) if(!fread((void *)x,sizeof(int),(size_t)n,Input)) err_fread(p);
#define RU(x,n) if(!fread((void *)x,sizeof(unsigned),(size_t)n,Input)) err_fread(p);
#define RUS(x,n) if(!fread((void *)x,sizeof(unsigned short),(size_t)n,Input)) err_fread(p);

#endif


#define SINGLE_STREAM_STRING  "None-single_stream"
