/* This is the random number generator proposed by George Marsaglia in
   Florida State University Report: FSU-SCRI-87-50
   It was slightly modified by F. James to produce an array of pseudorandom
   numbers.
*/

/* From  ranmar.f  translated by f2c (version of 17 June 1991  16:43:01).
	 --------
   Then manually modified by M. Kolar to remove all references to
   -lf2c   and  "/usr/local/f2c/src/f2c.h", and to simplify the code.
*/

/* #include <stdio.h>  */

#define PR	 (void)printf(
#define TRUE_	 (1)
#define FALSE_	 (0)

/* Common Block Declarations */
    float u[97], c, cd, cm;
    long int i97, j97;
    long int test = FALSE_;


/* Subroutine */ int rmarin1(ij, kl)  long int *ij, *kl;
		 /*===================================*/
{
    extern void exit();
    /* Local variables */
    static long int i, j, k, l, m;
    static float s, t;
    static long int ii, jj;

/*
 This is the initialization routine for the random number generator RANMAR()
  NOTE: The seed variables can have values between:    0 <= ij <= 31328 
                                                       0 <= kl <= 30081 
 The random number sequences created by these two seeds are of sufficient
 length to complete an entire calculation with. For example, if several 
 different groups are working on different parts of the same calculation,
 each group could be assigned its own ij seed. This would leave each group
 with 30000 choices for the second seed. That is to say, this random
 number generator can create 900 million different subsequences -- with 
 each subsequence having a length of approximately 10^30.

 Use ij = 1802 & kl = 9373 to test the random number generator. The
 subroutine RANMAR should be used to generate 20000 random numbers.
 Then display the next six random numbers generated multiplied by 4096*4096
 If the random number generator is working properly, the random numbers 
 should be:
            6533892.0  14220222.0  7275067.0
            6172232.0  8354498.0   10633180.0
*/
    if (*ij < 0 || *ij > 31328 || *kl < 0 || *kl > 30081) {
	PR" The first random number seed must have a value between 0 and\
 31328\n");
	PR" The second seed must have a value between 0 and 30081\n");
	PR"trouble in rmarin\n");
	exit(1);
    }
    i = *ij / 177 % 177 + 2;
    j = *ij % 177 + 2;
    k = *kl / 169 % 178 + 1;
    l = *kl % 169;
    for (ii = 1; ii <= 97; ++ii) {
	s = (float)0.;
	t = (float).5;
	for (jj = 1; jj <= 24; ++jj) {
	    m = i * j % 179 * k % 179;
	    i = j;
	    j = k;
	    k = m;
	    l = (l * 53 + 1) % 169;
	    if (l * m % 64 >= 32) {
		s += t;
	    }
	    t *= (float).5;
	}
	u[ii - 1] = s;
    }
    c = (float).021602869033813477;
    cd = (float).45623308420181274;
    cm = (float).99999982118606567;
    i97 = 97 - 1;
    j97 = 33 - 1;
    test = TRUE_;
    return 0;
} /* rmarin_ */

double ranmar1()
/*============*/
{
    /* Local variables */
    static float uni;

    if (! test) {
	PR" Call the init routine (RMARIN) before calling RANMAR\n");
	PR"trouble in ranmar\n");
	exit(1);
    }
    uni = u[i97] - u[j97];
    if (uni < (float)0.) uni += (float)1.;
    u[i97] = uni;
    --i97;
    if (i97 == -1) i97 = 96;
    --j97;
    if (j97 == -1) j97 = 96;
    c -= cd;
    if (c < (float)0.) c += cm;
    uni -= c;
    if (uni < (float)0.) uni += (float)1.;
    return (double)uni;
} /* ranmar_ */

